PLaSK library

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | List of all members
plask::RectangularMeshBase2D Struct Referenceabstract

`#include <plask/mesh/rectangular_common.hpp>`

Inheritance diagram for plask::RectangularMeshBase2D:
[legend]
Collaboration diagram for plask::RectangularMeshBase2D:
[legend]

## Public Types
typedef plask::Boundary< RectangularMeshBase2D > | Boundary
| Boundary type.
Public Types inherited from plask::MeshD< 2 >
enum |
| Number of dimensions. More...
typedef Primitive< DIM >::DVec | LocalCoords
| Type of vector representing coordinates in local space.
typedef IndexedIterator< const MeshD< dimension >, LocalCoords > | const_iterator
| Random access iterator type which allow iterate over all points in this mesh, in order appointed by operator[].
typedef const_iterator | iterator
typedef const_iterator | Iterator

## Public Member Functions
virtual BoundaryNodeSet | createVerticalBoundaryAtLine (std::size_t line_nr_axis0) const =0
| Create a node set which includes one vertical (from bottom to top) line in mesh.
virtual BoundaryNodeSet | createVerticalBoundaryAtLine (std::size_t line_nr_axis0, std::size_t indexBegin, std::size_t indexEnd) const =0
| Create a node set which includes a range in vertical (from bottom to top) line in mesh.
virtual BoundaryNodeSet | createVerticalBoundaryNear (double axis0_coord) const =0
| Create a node set which includes one vertical (from bottom to top) line in mesh which lies nearest given coordinate.
virtual BoundaryNodeSet | createVerticalBoundaryNear (double axis0_coord, double from, double to) const =0
| Create a node set which includes one vertical (from bottom to top) segment in mesh which lies nearest given coordinate and has ends in given range.
virtual BoundaryNodeSet | createLeftBoundary () const =0
| Create a node set which includes one vertical, left (from bottom to top) line in mesh.
virtual BoundaryNodeSet | createRightBoundary () const =0
| Create a node set which includes one vertical, right (from bottom to top) line in mesh.
virtual BoundaryNodeSet | createLeftOfBoundary (const Box2D &box) const =0
| Create a node set which lies on left edge of the `box` (at mesh line nearest left edge and inside the box).
virtual BoundaryNodeSet | createRightOfBoundary (const Box2D &box) const =0
| Create a node set which lies on right edge of the `box` (at mesh line nearest right edge and inside the box).
virtual BoundaryNodeSet | createBottomOfBoundary (const Box2D &box) const =0
| Create a node set which lies on bottom edge of the `box` (at mesh line nearest bottom edge and inside the box).
virtual BoundaryNodeSet | createTopOfBoundary (const Box2D &box) const =0
| Create a node set which lies on top edge of the `box` (at mesh line nearest top edge and inside the box).
virtual BoundaryNodeSet | createHorizontalBoundaryAtLine (std::size_t line_nr_axis1) const =0
| Create a node set which includes one horizontal (from left to right) line in mesh.
virtual BoundaryNodeSet | createHorizontalBoundaryAtLine (std::size_t line_nr_axis1, std::size_t indexBegin, std::size_t indexEnd) const =0
| Create a node set which includes range in horizontal (from left to right) line in mesh.
virtual BoundaryNodeSet | createHorizontalBoundaryNear (double axis1_coord) const =0
| Create a node set which includes one horizontal (from left to right) line in mesh which lies nearest given coordinate.
virtual BoundaryNodeSet | createHorizontalBoundaryNear (double axis1_coord, double from, double to) const =0
| Create a node set which includes one horizontal (from left to right) segment in mesh which lies nearest given coordinate and has ends in given range.
virtual BoundaryNodeSet | createTopBoundary () const =0
| Create node set which includes one horizontal, top (from left to right) line in mesh.
virtual BoundaryNodeSet | createBottomBoundary () const =0
| Create node set which includes one horizontal, bottom (from left to right) line in mesh.
Public Member Functions inherited from plask::MeshD< 2 >
virtual LocalCoords | at (std::size_t index) const=0
| Get point with given mesh index.
LocalCoords | operator[] (std::size_t index) const
| Get point with given mesh index.
const_iterator | begin () const
const_iterator | end () const
| MeshD (const MeshD &PLASK_UNUSED(to_copy))
| Initialize this to be the same as `to_copy` but don't copy any changes observer.
| MeshD ()
MeshD & | operator= (const MeshD &PLASK_UNUSED(to_copy))
| Set this to be the same as `to_copy` but doesn't changed changes observer.
bool | operator== (const MeshD &to_compare) const
| Check if this mesh and `to_compare` represent the same sequence of points (have exactly the same points in the same order).
bool | operator!= (const MeshD &to_compare) const
| Check if this mesh and `to_compare` represent different sequences of points.
void | print (std::ostream &out) const override
| Print this to stream `out`.
Public Member Functions inherited from plask::Mesh
template<typename ClassT , typename methodT >
boost::signals2::connection | changedConnectMethod (ClassT *obj, methodT method, boost::signals2::connect_position at=boost::signals2::at_back)
| Connect a method to changed signal.
template<typename ClassT , typename methodT >
void | changedDisconnectMethod (ClassT *obj, methodT method)
template<typename EventT = Event, typename ... Args>
void | fireChanged (Args &&... event_constructor_params_without_source)
| Call changed with this as event source.
void | fireResized ()
| This method is called when the mesh is resized.
virtual std::size_t | size () const =0
virtual bool | empty () const
virtual void | writeXML (XMLElement &object) const
| Write mesh to XML.
virtual | ~Mesh ()
Public Member Functions inherited from plask::Printable
virtual | ~Printable ()
std::string | str () const
| Get string representation of this using print method.
Public Member Functions inherited from plask::MeshBase
virtual | ~MeshBase ()

## Static Public Member Functions
template<typename Predicate >
static Boundary | getBoundary (Predicate predicate)
static Boundary | getVerticalBoundaryAtLine (std::size_t line_nr_axis0)
| Get boundary which show one vertical (from bottom to top) line in mesh.
static Boundary | getVerticalBoundaryAtLine (std::size_t line_nr_axis0, std::size_t indexBegin, std::size_t indexEnd)
| Get boundary which show range in vertical (from bottom to top) line in mesh.
static Boundary | getVerticalBoundaryNear (double axis0_coord)
| Get boundary which show one vertical (from bottom to top) line in mesh which lies nearest given coordinate.
static Boundary | getVerticalBoundaryNear (double axis0_coord, double from, double to)
| Get boundary which show one vertical (from bottom to top) segment in mesh which lies nearest given coordinate and has ends in given range.
static Boundary | getLeftBoundary ()
| Get boundary which show one vertical, left (from bottom to top) line in mesh.
static Boundary | getRightBoundary ()
| Get boundary which show one vertical, right (from bottom to top) line in mesh.
static Boundary | getLeftOfBoundary (const Box2D &box)
| Get boundary which lies on left edge of the `box` (at mesh line nearest left edge and inside the box).
static Boundary | getRightOfBoundary (const Box2D &box)
| Get boundary which lies on right edge of the `box` (at mesh line nearest right edge and inside the box).
static Boundary | getBottomOfBoundary (const Box2D &box)
| Get boundary which lies on bottom edge of the `box` (at mesh line nearest bottom edge and inside the box).
static Boundary | getTopOfBoundary (const Box2D &box)
| Get boundary which lies on top edge of the `box` (at mesh line nearest top edge and inside the box).
static Boundary | getLeftOfBoundary (shared_ptr< const GeometryObject > object, const PathHints &path)
| Get boundary which lies on left edge of bounding-boxes of `object` (in `geometry` coordinates).
static Boundary | getLeftOfBoundary (shared_ptr< const GeometryObject > object)
| Get boundary which lies on left edge of bounding-boxes of `object` (in `geometry` coordinates).
static Boundary | getLeftOfBoundary (shared_ptr< const GeometryObject > object, const PathHints *path)
| Get boundary which lies on left edge of bounding-boxes of `object` (in `geometry` coordinates).
static Boundary | getRightOfBoundary (shared_ptr< const GeometryObject > object, const PathHints &path)
| Get boundary which lies on right edge of bounding-boxes of `object` (in `geometry` coordinates).
static Boundary | getRightOfBoundary (shared_ptr< const GeometryObject > object)
| Get boundary which lies on right edge of bounding-boxes of `object` (in `geometry` coordinates).
static Boundary | getRightOfBoundary (shared_ptr< const GeometryObject > object, const PathHints *path)
| Get boundary which lies on right edge of bounding-boxes of `object` (in `geometry` coordinates).
static Boundary | getBottomOfBoundary (shared_ptr< const GeometryObject > object, const PathHints &path)
| Get boundary which lies on bottom edge of bounding-boxes of `object` (in `geometry` coordinates).
static Boundary | getBottomOfBoundary (shared_ptr< const GeometryObject > object)
| Get boundary which lies on bottom edge of bounding-boxes of `object` (in `geometry` coordinates).
static Boundary | getBottomOfBoundary (shared_ptr< const GeometryObject > object, const PathHints *path)
| Get boundary which lies on bottom edge of bounding-boxes of `object` (in `geometry` coordinates).
static Boundary | getTopOfBoundary (shared_ptr< const GeometryObject > object, const PathHints &path)
| Get boundary which lies on top edge of bounding-boxes of `object` (in `geometry` coordinates).
static Boundary | getTopOfBoundary (shared_ptr< const GeometryObject > object)
| Get boundary which lies on top edge of bounding-boxes of `object` (in `geometry` coordinates).
static Boundary | getTopOfBoundary (shared_ptr< const GeometryObject > object, const PathHints *path)
| Get boundary which lies on top edge of bounding-boxes of `object` (in `geometry` coordinates).
static Boundary | getHorizontalBoundaryAtLine (std::size_t line_nr_axis1)
| Get boundary which shows one horizontal (from left to right) line in mesh.
static Boundary | getHorizontalBoundaryAtLine (std::size_t line_nr_axis1, std::size_t indexBegin, std::size_t indexEnd)
| Get boundary which shows range in horizontal (from left to right) line in mesh.
static Boundary | getHorizontalBoundaryNear (double axis1_coord)
| Get boundary which shows one horizontal (from left to right) line in mesh which lies nearest given coordinate.
static Boundary | getHorizontalBoundaryNear (double axis1_coord, double from, double to)
| Get boundary which show one horizontal (from left to right) segment in mesh which lies nearest given coordinate and has ends in given range.
static Boundary | getTopBoundary ()
| Get boundary which shows one horizontal, top (from left to right) line in mesh.
static Boundary | getBottomBoundary ()
| Get boundary which shows one horizontal, bottom (from left to right) line in mesh.
static Boundary | getBoundary (const std::string &boundary_desc)
static Boundary | getBoundary (XMLReader &boundary_desc, Manager &manager)

## Additional Inherited Members
Public Attributes inherited from plask::Mesh
boost::signals2::signal< void(Event &)> | changed
| Changed signal, fired when mesh was changed.
Protected Member Functions inherited from plask::MeshD< 2 >
virtual bool | hasSameNodes (const MeshD< dimension > &to_compare) const
| Check if this mesh and `to_compare` represent the same sequence of points (have exactly the same points in the same order).
Protected Member Functions inherited from plask::Mesh
virtual void | onChange (const Event &evt)
| This method is called when the mesh is changed, just before changed signal.

## Detailed Description

Definition at line 191 of file rectangular_common.hpp.

## Member Typedef Documentation

## ◆ Boundary

typedef plask::Boundary<RectangularMeshBase2D> plask::RectangularMeshBase2D::Boundary

Boundary type.

Definition at line 194 of file rectangular_common.hpp.

## Member Function Documentation

## ◆ createBottomBoundary()

virtual BoundaryNodeSet plask::RectangularMeshBase2D::createBottomBoundary | ( |  | ) | const
| pure virtual

Create node set which includes one horizontal, bottom (from left to right) line in mesh.

Returns
  node set which includes bottom line in mesh

Implemented in plask::RectangularMesh2D.

## ◆ createBottomOfBoundary()

virtual BoundaryNodeSet plask::RectangularMeshBase2D::createBottomOfBoundary | ( | const Box2D & | box | ) | const
| pure virtual

Create a node set which lies on bottom edge of the `box` (at mesh line nearest bottom edge and inside the box).

Parameters

  box | box in which boundary should lie

Returns
  node set which lies on bottom edge of the `box` or empty boundary if there are no mesh indexes which lies inside the `box`

Implemented in plask::RectangularMesh2D.

## ◆ createHorizontalBoundaryAtLine() [1/2]

virtual BoundaryNodeSet plask::RectangularMeshBase2D::createHorizontalBoundaryAtLine | ( | std::size_t | line_nr_axis1 | ) | const
| pure virtual

Create a node set which includes one horizontal (from left to right) line in mesh.

Parameters

  line_nr_axis1 | number of horizontal line, index of axis1 mesh

Returns
  node set which includes one horizontal (from left to right) line in mesh

Implemented in plask::RectangularMesh2D.

## ◆ createHorizontalBoundaryAtLine() [2/2]

virtual BoundaryNodeSet plask::RectangularMeshBase2D::createHorizontalBoundaryAtLine | ( | std::size_t | line_nr_axis1,
|  | std::size_t | indexBegin,
|  | std::size_t | indexEnd
| ) |  | const
| pure virtual

Create a node set which includes range in horizontal (from left to right) line in mesh.

Parameters

  line_nr_axis1 | number of horizontal line, index of axis1 mesh
  indexBegin,indexEnd | ends of [indexBegin, indexEnd) range in line

Returns
  node set which includes range in horizontal (from left to right) line in mesh.

Implemented in plask::RectangularMesh2D.

## ◆ createHorizontalBoundaryNear() [1/2]

virtual BoundaryNodeSet plask::RectangularMeshBase2D::createHorizontalBoundaryNear | ( | double | axis1_coord | ) | const
| pure virtual

Create a node set which includes one horizontal (from left to right) line in mesh which lies nearest given coordinate.

Parameters

  axis1_coord | axis 1 coordinate

Returns
  boundary which includes one horizontal (from left to right) line in mesh

Implemented in plask::RectangularMesh2D.

## ◆ createHorizontalBoundaryNear() [2/2]

virtual BoundaryNodeSet plask::RectangularMeshBase2D::createHorizontalBoundaryNear | ( | double | axis1_coord,
|  | double | from,
|  | double | to
| ) |  | const
| pure virtual

Create a node set which includes one horizontal (from left to right) segment in mesh which lies nearest given coordinate and has ends in given range.

Parameters

  axis1_coord | axis 1 coordinate
  from,to | ends of line segment, [from, to] range of axis 0 coordinates

Returns
  node set which includes one horizontal (from left to right) line in mesh

Implemented in plask::RectangularMesh2D.

## ◆ createLeftBoundary()

virtual BoundaryNodeSet plask::RectangularMeshBase2D::createLeftBoundary | ( |  | ) | const
| pure virtual

Create a node set which includes one vertical, left (from bottom to top) line in mesh.

Returns
  node set which includes left line in mesh

Implemented in plask::RectangularMesh2D.

## ◆ createLeftOfBoundary()

virtual BoundaryNodeSet plask::RectangularMeshBase2D::createLeftOfBoundary | ( | const Box2D & | box | ) | const
| pure virtual

Create a node set which lies on left edge of the `box` (at mesh line nearest left edge and inside the box).

Parameters

  box | box in which boundary should lie

Returns
  node set which lies on left edge of the `box` or empty boundary if there are no mesh indexes which lies inside the `box`

Implemented in plask::RectangularMesh2D.

## ◆ createRightBoundary()

virtual BoundaryNodeSet plask::RectangularMeshBase2D::createRightBoundary | ( |  | ) | const
| pure virtual

Create a node set which includes one vertical, right (from bottom to top) line in mesh.

Returns
  node set which includes right line in mesh

Implemented in plask::RectangularMesh2D.

## ◆ createRightOfBoundary()

virtual BoundaryNodeSet plask::RectangularMeshBase2D::createRightOfBoundary | ( | const Box2D & | box | ) | const
| pure virtual

Create a node set which lies on right edge of the `box` (at mesh line nearest right edge and inside the box).

Parameters

  box | box in which boundary should lie

Returns
  node set which lies on right edge of the `box` or empty boundary if there are no mesh indexes which lies inside the `box`

Implemented in plask::RectangularMesh2D.

## ◆ createTopBoundary()

virtual BoundaryNodeSet plask::RectangularMeshBase2D::createTopBoundary | ( |  | ) | const
| pure virtual

Create node set which includes one horizontal, top (from left to right) line in mesh.

Returns
  node set which includes top line in mesh

Implemented in plask::RectangularMesh2D.

## ◆ createTopOfBoundary()

virtual BoundaryNodeSet plask::RectangularMeshBase2D::createTopOfBoundary | ( | const Box2D & | box | ) | const
| pure virtual

Create a node set which lies on top edge of the `box` (at mesh line nearest top edge and inside the box).

Parameters

  box | box in which boundary should lie

Returns
  node set which lies on top edge of the `box` or empty boundary if there are no mesh indexes which lies inside the `box`

Implemented in plask::RectangularMesh2D.

## ◆ createVerticalBoundaryAtLine() [1/2]

virtual BoundaryNodeSet plask::RectangularMeshBase2D::createVerticalBoundaryAtLine | ( | std::size_t | line_nr_axis0 | ) | const
| pure virtual

Create a node set which includes one vertical (from bottom to top) line in mesh.

Parameters

  line_nr_axis0 | number of vertical line, axis 0 index of mesh

Returns
  node set which includes one vertical (from bottom to top) line in mesh

Implemented in plask::RectangularMesh2D.

## ◆ createVerticalBoundaryAtLine() [2/2]

virtual BoundaryNodeSet plask::RectangularMeshBase2D::createVerticalBoundaryAtLine | ( | std::size_t | line_nr_axis0,
|  | std::size_t | indexBegin,
|  | std::size_t | indexEnd
| ) |  | const
| pure virtual

Create a node set which includes a range in vertical (from bottom to top) line in mesh.

Parameters

  line_nr_axis0 | number of vertical line, axis 0 index of mesh
  indexBegin,indexEnd | ends of [indexBegin, indexEnd) range in line

Returns
  node set which includes range in vertical (from bottom to top) line in mesh.

Implemented in plask::RectangularMesh2D.

## ◆ createVerticalBoundaryNear() [1/2]

virtual BoundaryNodeSet plask::RectangularMeshBase2D::createVerticalBoundaryNear | ( | double | axis0_coord | ) | const
| pure virtual

Create a node set which includes one vertical (from bottom to top) line in mesh which lies nearest given coordinate.

Parameters

  axis0_coord | axis 0 coordinate

Returns
  node set which includes one vertical (from bottom to top) line in mesh

Implemented in plask::RectangularMesh2D.

## ◆ createVerticalBoundaryNear() [2/2]

virtual BoundaryNodeSet plask::RectangularMeshBase2D::createVerticalBoundaryNear | ( | double | axis0_coord,
|  | double | from,
|  | double | to
| ) |  | const
| pure virtual

Create a node set which includes one vertical (from bottom to top) segment in mesh which lies nearest given coordinate and has ends in given range.

Parameters

  axis0_coord | axis 0 coordinate
  from,to | ends of line segment, [from, to] range of axis 1 coordinates

Returns
  node set which includes one vertical (from bottom to top) segment in mesh

Implemented in plask::RectangularMesh2D.

## ◆ getBottomBoundary()

static Boundary plask::RectangularMeshBase2D::getBottomBoundary | ( |  | ) |
| inline static

Get boundary which shows one horizontal, bottom (from left to right) line in mesh.

Returns
  boundary which show bottom line in mesh

Definition at line 628 of file rectangular_common.hpp.

## ◆ getBottomOfBoundary() [1/4]

static Boundary plask::RectangularMeshBase2D::getBottomOfBoundary | ( | const Box2D & | box | ) |
| inline static

Get boundary which lies on bottom edge of the `box` (at mesh line nearest bottom edge and inside the box).

Parameters

  box | box in which boundary should lie

Returns
  boundary which lies on bottom edge of the `box` or empty boundary if there are no mesh indexes which lies inside the `box`

Definition at line 360 of file rectangular_common.hpp.

## ◆ getBottomOfBoundary() [2/4]

static Boundary plask::RectangularMeshBase2D::getBottomOfBoundary | ( | shared_ptr< const GeometryObject > | object | ) |
| inline static

Get boundary which lies on bottom edge of bounding-boxes of `object` (in `geometry` coordinates).

Parameters

  object | object included in `geometry`

Returns
  boundary which represents sum of boundaries of bottom edges of `object's` bounding-boxes

Definition at line 474 of file rectangular_common.hpp.

## ◆ getBottomOfBoundary() [3/4]

static Boundary plask::RectangularMeshBase2D::getBottomOfBoundary | ( | shared_ptr< const GeometryObject > | object,
|  | const PathHints & | path
| ) |  |
| inline static

Get boundary which lies on bottom edge of bounding-boxes of `object` (in `geometry` coordinates).

Parameters

  object | object included in `geometry`
  path | hints specifying particular instances of the geometry object

Returns
  boundary which represents sum of boundaries of bottom edges of `object's` bounding-boxes

Definition at line 462 of file rectangular_common.hpp.

## ◆ getBottomOfBoundary() [4/4]

static Boundary plask::RectangularMeshBase2D::getBottomOfBoundary | ( | shared_ptr< const GeometryObject > | object,
|  | const PathHints * | path
| ) |  |
| inline static

Get boundary which lies on bottom edge of bounding-boxes of `object` (in `geometry` coordinates).

Parameters

  object | object included in `geometry`
  path | (optional) hints specifying particular instances of the geometry object

Returns
  boundary which represents sum of boundaries of bottom edges of `object's` bounding-boxes

Definition at line 487 of file rectangular_common.hpp.

## ◆ getBoundary() [1/3]

RectangularMeshBase2D::Boundary plask::RectangularMeshBase2D::getBoundary | ( | const std::string & | boundary_desc | ) |
| static

Definition at line 31 of file rectangular_common.cpp.

## ◆ getBoundary() [2/3]

template<typename Predicate >

static Boundary plask::RectangularMeshBase2D::getBoundary | ( | Predicate | predicate | ) |
| inline static

Definition at line 197 of file rectangular_common.hpp.

## ◆ getBoundary() [3/3]

RectangularMeshBase2D::Boundary plask::RectangularMeshBase2D::getBoundary | ( | XMLReader & | boundary_desc,
|  | Manager & | manager
| ) |  |
| static

Definition at line 39 of file rectangular_common.cpp.

## ◆ getHorizontalBoundaryAtLine() [1/2]

static Boundary plask::RectangularMeshBase2D::getHorizontalBoundaryAtLine | ( | std::size_t | line_nr_axis1 | ) |
| inline static

Get boundary which shows one horizontal (from left to right) line in mesh.

Parameters

  line_nr_axis1 | number of horizontal line, index of axis1 mesh

Returns
  boundary which shows one horizontal (from left to right) line in mesh

Definition at line 538 of file rectangular_common.hpp.

## ◆ getHorizontalBoundaryAtLine() [2/2]

static Boundary plask::RectangularMeshBase2D::getHorizontalBoundaryAtLine | ( | std::size_t | line_nr_axis1,
|  | std::size_t | indexBegin,
|  | std::size_t | indexEnd
| ) |  |
| inline static

Get boundary which shows range in horizontal (from left to right) line in mesh.

Parameters

  line_nr_axis1 | number of horizontal line, index of axis1 mesh
  indexBegin,indexEnd | ends of [indexBegin, indexEnd) range in line

Returns
  boundary which shows range in horizontal (from left to right) line in mesh.

Definition at line 558 of file rectangular_common.hpp.

## ◆ getHorizontalBoundaryNear() [1/2]

static Boundary plask::RectangularMeshBase2D::getHorizontalBoundaryNear | ( | double | axis1_coord | ) |
| inline static

Get boundary which shows one horizontal (from left to right) line in mesh which lies nearest given coordinate.

Parameters

  axis1_coord | axis 1 coordinate

Returns
  boundary which shows one horizontal (from left to right) line in mesh

Definition at line 576 of file rectangular_common.hpp.

## ◆ getHorizontalBoundaryNear() [2/2]

static Boundary plask::RectangularMeshBase2D::getHorizontalBoundaryNear | ( | double | axis1_coord,
|  | double | from,
|  | double | to
| ) |  |
| inline static

Get boundary which show one horizontal (from left to right) segment in mesh which lies nearest given coordinate and has ends in given range.

Parameters

  axis1_coord | axis 1 coordinate
  from,to | ends of line segment, [from, to] range of axis 0 coordinates

Returns
  boundary which shows one horizontal (from left to right) line in mesh

Definition at line 596 of file rectangular_common.hpp.

## ◆ getLeftBoundary()

static Boundary plask::RectangularMeshBase2D::getLeftBoundary | ( |  | ) |
| inline static

Get boundary which show one vertical, left (from bottom to top) line in mesh.

Returns
  boundary which shows left line in mesh

Definition at line 287 of file rectangular_common.hpp.

## ◆ getLeftOfBoundary() [1/4]

static Boundary plask::RectangularMeshBase2D::getLeftOfBoundary | ( | const Box2D & | box | ) |
| inline static

Get boundary which lies on left edge of the `box` (at mesh line nearest left edge and inside the box).

Parameters

  box | box in which boundary should lie

Returns
  boundary which lies on left edge of the `box` or empty boundary if there are no mesh indexes which lies inside the `box`

Definition at line 322 of file rectangular_common.hpp.

## ◆ getLeftOfBoundary() [2/4]

static Boundary plask::RectangularMeshBase2D::getLeftOfBoundary | ( | shared_ptr< const GeometryObject > | object | ) |
| inline static

Get boundary which lies on left edge of bounding-boxes of `object` (in `geometry` coordinates).

Parameters

  object | object included in `geometry`

Returns
  boundary which represents sum of boundaries of left edges of `object's` bounding-boxes

Definition at line 404 of file rectangular_common.hpp.

## ◆ getLeftOfBoundary() [3/4]

static Boundary plask::RectangularMeshBase2D::getLeftOfBoundary | ( | shared_ptr< const GeometryObject > | object,
|  | const PathHints & | path
| ) |  |
| inline static

Get boundary which lies on left edge of bounding-boxes of `object` (in `geometry` coordinates).

Parameters

  object | object included in `geometry`
  path | hints specifying particular instances of the geometry object

Returns
  boundary which represents sum of boundaries of left edges of `object's` bounding-boxes

Definition at line 392 of file rectangular_common.hpp.

## ◆ getLeftOfBoundary() [4/4]

static Boundary plask::RectangularMeshBase2D::getLeftOfBoundary | ( | shared_ptr< const GeometryObject > | object,
|  | const PathHints * | path
| ) |  |
| inline static

Get boundary which lies on left edge of bounding-boxes of `object` (in `geometry` coordinates).

Parameters

  object | object included in `geometry`
  path | (optional) hints specifying particular instances of the geometry object

Returns
  boundary which represents sum of boundaries of left edges of `object's` bounding-boxes

Definition at line 417 of file rectangular_common.hpp.

## ◆ getRightBoundary()

static Boundary plask::RectangularMeshBase2D::getRightBoundary | ( |  | ) |
| inline static

Get boundary which show one vertical, right (from bottom to top) line in mesh.

Returns
  boundary which shows right line in mesh

Definition at line 304 of file rectangular_common.hpp.

## ◆ getRightOfBoundary() [1/4]

static Boundary plask::RectangularMeshBase2D::getRightOfBoundary | ( | const Box2D & | box | ) |
| inline static

Get boundary which lies on right edge of the `box` (at mesh line nearest right edge and inside the box).

Parameters

  box | box in which boundary should lie

Returns
  boundary which lies on right edge of the `box` or empty boundary if there are no mesh indexes which lies inside the `box`

Definition at line 341 of file rectangular_common.hpp.

## ◆ getRightOfBoundary() [2/4]

static Boundary plask::RectangularMeshBase2D::getRightOfBoundary | ( | shared_ptr< const GeometryObject > | object | ) |
| inline static

Get boundary which lies on right edge of bounding-boxes of `object` (in `geometry` coordinates).

Parameters

  object | object included in `geometry`

Returns
  boundary which represents sum of boundaries of right edges of `object's` bounding-boxes

Definition at line 439 of file rectangular_common.hpp.

## ◆ getRightOfBoundary() [3/4]

static Boundary plask::RectangularMeshBase2D::getRightOfBoundary | ( | shared_ptr< const GeometryObject > | object,
|  | const PathHints & | path
| ) |  |
| inline static

Get boundary which lies on right edge of bounding-boxes of `object` (in `geometry` coordinates).

Parameters

  object | object included in `geometry`
  path | hints specifying particular instances of the geometry object

Returns
  boundary which represents sum of boundaries of right edges of `object's` bounding-boxes

Definition at line 427 of file rectangular_common.hpp.

## ◆ getRightOfBoundary() [4/4]

static Boundary plask::RectangularMeshBase2D::getRightOfBoundary | ( | shared_ptr< const GeometryObject > | object,
|  | const PathHints * | path
| ) |  |
| inline static

Get boundary which lies on right edge of bounding-boxes of `object` (in `geometry` coordinates).

Parameters

  object | object included in `geometry`
  path | (optional) hints specifying particular instances of the geometry object

Returns
  boundary which represents sum of boundaries of right edges of `object's` bounding-boxes

Definition at line 452 of file rectangular_common.hpp.

## ◆ getTopBoundary()

static Boundary plask::RectangularMeshBase2D::getTopBoundary | ( |  | ) |
| inline static

Get boundary which shows one horizontal, top (from left to right) line in mesh.

Returns
  boundary which show top line in mesh

Definition at line 612 of file rectangular_common.hpp.

## ◆ getTopOfBoundary() [1/4]

static Boundary plask::RectangularMeshBase2D::getTopOfBoundary | ( | const Box2D & | box | ) |
| inline static

Get boundary which lies on top edge of the `box` (at mesh line nearest top edge and inside the box).

Parameters

  box | box in which boundary should lie

Returns
  boundary which lies on top edge of the `box` or empty boundary if there are no mesh indexes which lies inside the `box`

Definition at line 379 of file rectangular_common.hpp.

## ◆ getTopOfBoundary() [2/4]

static Boundary plask::RectangularMeshBase2D::getTopOfBoundary | ( | shared_ptr< const GeometryObject > | object | ) |
| inline static

Get boundary which lies on top edge of bounding-boxes of `object` (in `geometry` coordinates).

Parameters

  object | object included in `geometry`

Returns
  boundary which represents sum of boundaries of top edges of `object's` bounding-boxes

Definition at line 509 of file rectangular_common.hpp.

## ◆ getTopOfBoundary() [3/4]

static Boundary plask::RectangularMeshBase2D::getTopOfBoundary | ( | shared_ptr< const GeometryObject > | object,
|  | const PathHints & | path
| ) |  |
| inline static

Get boundary which lies on top edge of bounding-boxes of `object` (in `geometry` coordinates).

Parameters

  object | object included in `geometry`
  path | hints specifying particular instances of the geometry object

Returns
  boundary which represents sum of boundaries of top edges of `object's` bounding-boxes

Definition at line 497 of file rectangular_common.hpp.

## ◆ getTopOfBoundary() [4/4]

static Boundary plask::RectangularMeshBase2D::getTopOfBoundary | ( | shared_ptr< const GeometryObject > | object,
|  | const PathHints * | path
| ) |  |
| inline static

Get boundary which lies on top edge of bounding-boxes of `object` (in `geometry` coordinates).

Parameters

  object | object included in `geometry`
  path | (optional) hints specifying particular instances of the geometry object

Returns
  boundary which represents sum of boundaries of top edges of `object's` bounding-boxes

Definition at line 522 of file rectangular_common.hpp.

## ◆ getVerticalBoundaryAtLine() [1/2]

static Boundary plask::RectangularMeshBase2D::getVerticalBoundaryAtLine | ( | std::size_t | line_nr_axis0 | ) |
| inline static

Get boundary which show one vertical (from bottom to top) line in mesh.

Parameters

  line_nr_axis0 | number of vertical line, axis 0 index of mesh

Returns
  boundary which shows one vertical (from bottom to top) line in mesh

Definition at line 213 of file rectangular_common.hpp.

## ◆ getVerticalBoundaryAtLine() [2/2]

static Boundary plask::RectangularMeshBase2D::getVerticalBoundaryAtLine | ( | std::size_t | line_nr_axis0,
|  | std::size_t | indexBegin,
|  | std::size_t | indexEnd
| ) |  |
| inline static

Get boundary which show range in vertical (from bottom to top) line in mesh.

Parameters

  line_nr_axis0 | number of vertical line, axis 0 index of mesh
  indexBegin,indexEnd | ends of [indexBegin, indexEnd) range in line

Returns
  boundary which shows range in vertical (from bottom to top) line in mesh.

Definition at line 233 of file rectangular_common.hpp.

## ◆ getVerticalBoundaryNear() [1/2]

static Boundary plask::RectangularMeshBase2D::getVerticalBoundaryNear | ( | double | axis0_coord | ) |
| inline static

Get boundary which show one vertical (from bottom to top) line in mesh which lies nearest given coordinate.

Parameters

  axis0_coord | axis 0 coordinate

Returns
  boundary which shows one vertical (from bottom to top) line in mesh

Definition at line 251 of file rectangular_common.hpp.

## ◆ getVerticalBoundaryNear() [2/2]

static Boundary plask::RectangularMeshBase2D::getVerticalBoundaryNear | ( | double | axis0_coord,
|  | double | from,
|  | double | to
| ) |  |
| inline static

Get boundary which show one vertical (from bottom to top) segment in mesh which lies nearest given coordinate and has ends in given range.

Parameters

  axis0_coord | axis 0 coordinate
  from,to | ends of line segment, [from, to] range of axis 1 coordinates

Returns
  boundary which shows one vertical (from bottom to top) segment in mesh

Definition at line 271 of file rectangular_common.hpp.

The documentation for this struct was generated from the following files:

- plask/mesh/rectangular_common.hpp
- plask/mesh/rectangular_common.cpp